From c0a80d282aed7d170d7449956bde6f4e06715daa Mon Sep 17 00:00:00 2001
From: Akshay Adhikari <aadhikar@redhat.com>
Date: Jul 02 2018 14:21:38 +0000
Subject: Issue 49588 - Add py3 support for tickets : part-3


Description: Added py3 support by explicitly changing strings to bytes.

https://pagure.io/389-ds-base/issue/49588

Reviewed by: vashirov (Thanks!)

---

diff --git a/dirsrvtests/tests/tickets/ticket47560_test.py b/dirsrvtests/tests/tickets/ticket47560_test.py
index 175b712..273f944 100644
--- a/dirsrvtests/tests/tickets/ticket47560_test.py
+++ b/dirsrvtests/tests/tickets/ticket47560_test.py
@@ -15,6 +15,7 @@ from lib389 import Entry
 from lib389._constants import *
 from lib389.properties import *
 from lib389.topologies import topology_st
+from lib389.utils import *
 
 log = logging.getLogger(__name__)
 
@@ -95,7 +96,7 @@ def test_ticket47560(topology_st):
         except ldap.ALREADY_EXISTS:
             log.debug("Entry %s already exists" % (member_DN))
 
-        replace = [(ldap.MOD_REPLACE, 'memberof', group_DN)]
+        replace = [(ldap.MOD_REPLACE, 'memberof', ensure_bytes(group_DN))]
         topology_st.standalone.modify_s(member_DN, replace)
 
         #
@@ -111,7 +112,7 @@ def test_ticket47560(topology_st):
         assert len(ents) == 1
         ent = ents[0]
         # print ent
-        value = ent.getValue('memberof')
+        value = ensure_str(ent.getValue('memberof'))
         # print "memberof: %s" % (value)
         assert value == group_DN
 
@@ -165,7 +166,7 @@ def test_ticket47560(topology_st):
     ent = ents[0]
     log.debug("Fixed entry %r\n" % ent)
 
-    if ent.getValue('memberof') == group_DN:
+    if ensure_str(ent.getValue('memberof')) == group_DN:
         log.warning("Error the fixupMemberOf did not fix %s" % (member_DN))
         result_successful = False
     else:
diff --git a/dirsrvtests/tests/tickets/ticket47573_test.py b/dirsrvtests/tests/tickets/ticket47573_test.py
index 1b443ef..5019ec1 100644
--- a/dirsrvtests/tests/tickets/ticket47573_test.py
+++ b/dirsrvtests/tests/tickets/ticket47573_test.py
@@ -20,6 +20,7 @@ import pytest
 from lib389 import Entry
 from lib389._constants import *
 from lib389.topologies import topology_m1c1
+from lib389.utils import *
 
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
@@ -68,7 +69,7 @@ def _oc_definition(oid_ext, name, must=None, may=None):
         may = MAY_OLD
 
     new_oc = "( %s  NAME '%s' DESC '%s' SUP %s AUXILIARY MUST %s MAY %s )" % (oid, name, desc, sup, must, may)
-    return new_oc
+    return ensure_bytes(new_oc)
 
 
 def add_OC(instance, oid_ext, name):
@@ -92,7 +93,7 @@ def trigger_schema_push(topology_m1c1):
         trigger_schema_push.value += 1
     except AttributeError:
         trigger_schema_push.value = 1
-    replace = [(ldap.MOD_REPLACE, 'telephonenumber', str(trigger_schema_push.value))]
+    replace = [(ldap.MOD_REPLACE, 'telephonenumber', ensure_bytes(str(trigger_schema_push.value)))]
     topology_m1c1.ms["master1"].modify_s(ENTRY_DN, replace)
 
     # wait 10 seconds that the update is replicated
diff --git a/dirsrvtests/tests/tickets/ticket47640_test.py b/dirsrvtests/tests/tickets/ticket47640_test.py
index 3a9f13c..833f9fb 100644
--- a/dirsrvtests/tests/tickets/ticket47640_test.py
+++ b/dirsrvtests/tests/tickets/ticket47640_test.py
@@ -28,7 +28,7 @@ def test_ticket47640(topology_st):
 
     # Enable Dynamic plugins, and the linked Attrs plugin
     try:
-        topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-dynamic-plugins', 'on')])
+        topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-dynamic-plugins', b'on')])
     except ldap.LDAPError as e:
         log.fatal('Failed to enable dynamic plugin!' + e.message['desc'])
         assert False
diff --git a/dirsrvtests/tests/tickets/ticket47653MMR_test.py b/dirsrvtests/tests/tickets/ticket47653MMR_test.py
index 6f6a5d4..c23a345 100644
--- a/dirsrvtests/tests/tickets/ticket47653MMR_test.py
+++ b/dirsrvtests/tests/tickets/ticket47653MMR_test.py
@@ -56,7 +56,7 @@ def _oc_definition(oid_ext, name, must=None, may=None):
         may = MAY
 
     new_oc = "( %s  NAME '%s' DESC '%s' SUP %s AUXILIARY MUST %s MAY %s )" % (oid, name, desc, sup, must, may)
-    return new_oc
+    return ensure_bytes(new_oc)
 
 
 def test_ticket47653_init(topology_m2):
@@ -82,7 +82,7 @@ def test_ticket47653_init(topology_m2):
 
     if DEBUGGING:
         # enable acl error logging
-        mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', str(128 + 8192))]  # ACL + REPL
+        mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', ensure_bytes(str(128 + 8192)))]  # ACL + REPL
         topology_m2.ms["master1"].modify_s(DN_CONFIG, mod)
         topology_m2.ms["master2"].modify_s(DN_CONFIG, mod)
 
@@ -159,7 +159,7 @@ def test_ticket47653_add(topology_m2):
     ACI_ALLOW = "(version 3.0; acl \"SelfDN add\"; allow (add)"
     ACI_SUBJECT = " userattr = \"member#selfDN\";)"
     ACI_BODY = ACI_TARGET + ACI_TARGETFILTER + ACI_ALLOW + ACI_SUBJECT
-    mod = [(ldap.MOD_ADD, 'aci', ACI_BODY)]
+    mod = [(ldap.MOD_ADD, 'aci', ensure_bytes(ACI_BODY))]
     topology_m2.ms["master1"].modify_s(SUFFIX, mod)
     time.sleep(1)
 
@@ -215,7 +215,7 @@ def test_ticket47653_add(topology_m2):
 
     # Now update the entry on Master2 (as DM because 47653 is possibly not fixed on M2)
     topology_m2.ms["master1"].log.info("Update  %s on M2" % ENTRY_DN)
-    mod = [(ldap.MOD_REPLACE, 'description', 'test_add')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'test_add')]
     topology_m2.ms["master2"].modify_s(ENTRY_DN, mod)
     time.sleep(1)
 
@@ -224,13 +224,13 @@ def test_ticket47653_add(topology_m2):
     while loop <= 10:
         try:
             ent = topology_m2.ms["master1"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'test_add'):
+            if ent.hasAttr('description') and (ensure_str(ent.getValue('description')) == 'test_add'):
                 break
         except ldap.NO_SUCH_OBJECT:
             time.sleep(1)
             loop += 1
 
-    assert ent.getValue('description') == 'test_add'
+    assert ensure_str(ent.getValue('description')) == 'test_add'
 
 
 def test_ticket47653_modify(topology_m2):
@@ -252,7 +252,7 @@ def test_ticket47653_modify(topology_m2):
     # entry to modify WITH member being BIND_DN but WITHOUT the ACI -> ldap.INSUFFICIENT_ACCESS
     try:
         topology_m2.ms["master1"].log.info("Try to modify  %s (aci is missing)" % ENTRY_DN)
-        mod = [(ldap.MOD_REPLACE, 'postalCode', '9876')]
+        mod = [(ldap.MOD_REPLACE, 'postalCode', b'9876')]
         topology_m2.ms["master1"].modify_s(ENTRY_DN, mod)
     except Exception as e:
         topology_m2.ms["master1"].log.info("Exception (expected): %s" % type(e).__name__)
@@ -268,7 +268,7 @@ def test_ticket47653_modify(topology_m2):
     ACI_ALLOW = "(version 3.0; acl \"SelfDN write\"; allow (write)"
     ACI_SUBJECT = " userattr = \"member#selfDN\";)"
     ACI_BODY = ACI_TARGET + ACI_TARGETATTR + ACI_TARGETFILTER + ACI_ALLOW + ACI_SUBJECT
-    mod = [(ldap.MOD_ADD, 'aci', ACI_BODY)]
+    mod = [(ldap.MOD_ADD, 'aci', ensure_bytes(ACI_BODY))]
     topology_m2.ms["master1"].modify_s(SUFFIX, mod)
     time.sleep(2)
 
@@ -279,7 +279,7 @@ def test_ticket47653_modify(topology_m2):
 
     # modify the entry and checks the value
     topology_m2.ms["master1"].log.info("M1: Try to modify  %s. It should succeeds" % ENTRY_DN)
-    mod = [(ldap.MOD_REPLACE, 'postalCode', '1928')]
+    mod = [(ldap.MOD_REPLACE, 'postalCode', b'1928')]
     topology_m2.ms["master1"].modify_s(ENTRY_DN, mod)
 
     topology_m2.ms["master1"].log.info("M1: Bind as %s" % DN_DM)
@@ -288,7 +288,7 @@ def test_ticket47653_modify(topology_m2):
     topology_m2.ms["master1"].log.info("M1: Check the update of %s" % ENTRY_DN)
     ents = topology_m2.ms["master1"].search_s(ENTRY_DN, ldap.SCOPE_BASE, 'objectclass=*')
     assert len(ents) == 1
-    assert ents[0].postalCode == '1928'
+    assert ensure_str(ents[0].postalCode) == '1928'
 
     # Now check the update has been replicated on M2
     topology_m2.ms["master1"].log.info("M2: Bind as %s" % DN_DM)
@@ -298,13 +298,13 @@ def test_ticket47653_modify(topology_m2):
     while loop <= 10:
         try:
             ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('postalCode') and (ent.getValue('postalCode') == '1928'):
+            if ent.hasAttr('postalCode') and (ensure_str(ent.getValue('postalCode')) == '1928'):
                 break
         except ldap.NO_SUCH_OBJECT:
             time.sleep(1)
             loop += 1
     assert loop <= 10
-    assert ent.getValue('postalCode') == '1928'
+    assert ensure_str(ent.getValue('postalCode')) == '1928'
 
     # Now update the entry on Master2 bound as BIND_DN (update may fail if  47653 is  not fixed on M2)
     topology_m2.ms["master1"].log.info("M2: Update  %s (bound as %s)" % (ENTRY_DN, BIND_DN))
@@ -312,7 +312,7 @@ def test_ticket47653_modify(topology_m2):
     time.sleep(1)
     fail = False
     try:
-        mod = [(ldap.MOD_REPLACE, 'postalCode', '1929')]
+        mod = [(ldap.MOD_REPLACE, 'postalCode', b'1929')]
         topology_m2.ms["master2"].modify_s(ENTRY_DN, mod)
         fail = False
     except ldap.INSUFFICIENT_ACCESS:
@@ -332,12 +332,12 @@ def test_ticket47653_modify(topology_m2):
         while loop <= 10:
             try:
                 ent = topology_m2.ms["master1"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
-                if ent.hasAttr('postalCode') and (ent.getValue('postalCode') == '1929'):
+                if ent.hasAttr('postalCode') and (ensure_str(ent.getValue('postalCode')) == '1929'):
                     break
             except ldap.NO_SUCH_OBJECT:
                 time.sleep(1)
                 loop += 1
-        assert ent.getValue('postalCode') == '1929'
+        assert ensure_str(ent.getValue('postalCode')) == '1929'
 
 
 if __name__ == '__main__':
diff --git a/dirsrvtests/tests/tickets/ticket47676_test.py b/dirsrvtests/tests/tickets/ticket47676_test.py
index 3468b90..fd6276b 100644
--- a/dirsrvtests/tests/tickets/ticket47676_test.py
+++ b/dirsrvtests/tests/tickets/ticket47676_test.py
@@ -19,6 +19,7 @@ import pytest
 from lib389 import Entry
 from lib389._constants import *
 from lib389.topologies import topology_m2
+from lib389.replica import ReplicationManager
 
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 from lib389.utils import *
@@ -66,8 +67,13 @@ def _oc_definition(oid_ext, name, must=None, may=None):
         may = MAY
 
     new_oc = "( %s  NAME '%s' DESC '%s' SUP %s AUXILIARY MUST %s MAY %s )" % (oid, name, desc, sup, must, may)
-    return new_oc
+    return ensure_bytes(new_oc)
 
+def replication_check(topology_m2):
+    repl = ReplicationManager(SUFFIX)
+    master1 = topology_m2.ms["master1"]
+    master2 = topology_m2.ms["master2"]
+    return repl.test_replication(master1, master2)
 
 def test_ticket47676_init(topology_m2):
     """
@@ -91,7 +97,7 @@ def test_ticket47676_init(topology_m2):
         'userpassword': BIND_PW})))
 
     # enable acl error logging
-    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', str(128 + 8192))]  # ACL + REPL
+    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', ensure_bytes(str(128 + 8192)))]  # ACL + REPL
     topology_m2.ms["master1"].modify_s(DN_CONFIG, mod)
     topology_m2.ms["master2"].modify_s(DN_CONFIG, mod)
 
@@ -138,31 +144,18 @@ def test_ticket47676_skip_oc_at(topology_m2):
     #
     topology_m2.ms["master2"].simple_bind_s(DN_DM, PASSWORD)
     topology_m2.ms["master1"].log.info("Try to retrieve %s from Master2" % ENTRY_DN)
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
-            break
-        except ldap.NO_SUCH_OBJECT:
-            time.sleep(2)
-            loop += 1
-    assert loop <= 10
-
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ent
     # Now update the entry on Master2 (as DM because 47676 is possibly not fixed on M2)
     topology_m2.ms["master1"].log.info("Update  %s on M2" % ENTRY_DN)
-    mod = [(ldap.MOD_REPLACE, 'description', 'test_add')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'test_add')]
     topology_m2.ms["master2"].modify_s(ENTRY_DN, mod)
 
     topology_m2.ms["master1"].simple_bind_s(DN_DM, PASSWORD)
-    loop = 0
-    while loop <= 10:
-        ent = topology_m2.ms["master1"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
-        if ent.hasAttr('description') and (ent.getValue('description') == 'test_add'):
-            break
-        time.sleep(1)
-        loop += 1
-
-    assert ent.getValue('description') == 'test_add'
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master1"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'test_add'
 
 
 def test_ticket47676_reject_action(topology_m2):
@@ -172,7 +165,7 @@ def test_ticket47676_reject_action(topology_m2):
     topology_m2.ms["master2"].simple_bind_s(DN_DM, PASSWORD)
 
     # make master1 to refuse to push the schema if OC_NAME is present in consumer schema
-    mod = [(ldap.MOD_ADD, 'schemaUpdateObjectclassReject', '%s' % (OC_NAME))]  # ACL + REPL
+    mod = [(ldap.MOD_ADD, 'schemaUpdateObjectclassReject', ensure_bytes('%s' % (OC_NAME)))]  # ACL + REPL
     topology_m2.ms["master1"].modify_s(REPL_SCHEMA_POLICY_SUPPLIER, mod)
 
     # Restart is required to take into account that policy
@@ -197,20 +190,15 @@ def test_ticket47676_reject_action(topology_m2):
 
     # Do an update of M1 so that M1 will try to push the schema
     topology_m2.ms["master1"].log.info("Update  %s on M1" % ENTRY_DN)
-    mod = [(ldap.MOD_REPLACE, 'description', 'test_reject')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'test_reject')]
     topology_m2.ms["master1"].modify_s(ENTRY_DN, mod)
 
     # Check the replication occured and so also M1 attempted to push the schema
     topology_m2.ms["master1"].log.info("Check updated %s on M2" % ENTRY_DN)
-    loop = 0
-    while loop <= 10:
-        ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)", ['description'])
-        if ent.hasAttr('description') and ent.getValue('description') == 'test_reject':
-            # update was replicated
-            break
-        time.sleep(2)
-        loop += 1
-    assert loop <= 10
+
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)", ['description'])
+    assert ensure_str(ent.getValue('description')) == 'test_reject'
 
     # Check that the schema has not been pushed
     topology_m2.ms["master1"].log.info("Check %s is not in M2" % OC2_NAME)
@@ -226,7 +214,7 @@ def test_ticket47676_reject_action(topology_m2):
     topology_m2.ms["master1"].log.info("\n\n######################### NO MORE REJECT ACTION ######################\n")
 
     # make master1 to do no specific action on OC_NAME
-    mod = [(ldap.MOD_DELETE, 'schemaUpdateObjectclassReject', '%s' % (OC_NAME))]  # ACL + REPL
+    mod = [(ldap.MOD_DELETE, 'schemaUpdateObjectclassReject', ensure_bytes('%s' % (OC_NAME)))]  # ACL + REPL
     topology_m2.ms["master1"].modify_s(REPL_SCHEMA_POLICY_SUPPLIER, mod)
 
     # Restart is required to take into account that policy
@@ -235,21 +223,15 @@ def test_ticket47676_reject_action(topology_m2):
 
     # Do an update of M1 so that M1 will try to push the schema
     topology_m2.ms["master1"].log.info("Update  %s on M1" % ENTRY_DN)
-    mod = [(ldap.MOD_REPLACE, 'description', 'test_no_more_reject')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'test_no_more_reject')]
     topology_m2.ms["master1"].modify_s(ENTRY_DN, mod)
 
     # Check the replication occured and so also M1 attempted to push the schema
     topology_m2.ms["master1"].log.info("Check updated %s on M2" % ENTRY_DN)
-    loop = 0
-    while loop <= 10:
-        ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)", ['description'])
-        if ent.hasAttr('description') and ent.getValue('description') == 'test_no_more_reject':
-            # update was replicated
-            break
-        time.sleep(2)
-        loop += 1
-    assert loop <= 10
 
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(ENTRY_DN, ldap.SCOPE_BASE, "(objectclass=*)", ['description'])
+    assert ensure_str(ent.getValue('description')) == 'test_no_more_reject'
     # Check that the schema has been pushed
     topology_m2.ms["master1"].log.info("Check %s is in M2" % OC2_NAME)
     ent = topology_m2.ms["master2"].getEntry(SCHEMA_DN, ldap.SCOPE_BASE, "(objectclass=*)", ["objectclasses"])
diff --git a/dirsrvtests/tests/tickets/ticket47714_test.py b/dirsrvtests/tests/tickets/ticket47714_test.py
index 5ef9f9d..9e931e8 100644
--- a/dirsrvtests/tests/tickets/ticket47714_test.py
+++ b/dirsrvtests/tests/tickets/ticket47714_test.py
@@ -80,12 +80,12 @@ def test_ticket47714_run_0(topology_st):
     topology_st.standalone.simple_bind_s(DN_DM, PASSWORD)
 
     # Modify Account Policy config entry
-    topology_st.standalone.modify_s(ACCT_POLICY_CONFIG_DN, [(ldap.MOD_REPLACE, 'alwaysrecordlogin', 'yes'),
-                                                            (ldap.MOD_REPLACE, 'stateattrname', 'lastLoginTime'),
-                                                            (ldap.MOD_REPLACE, 'altstateattrname', 'createTimestamp'),
-                                                            (ldap.MOD_REPLACE, 'specattrname', 'acctPolicySubentry'),
+    topology_st.standalone.modify_s(ACCT_POLICY_CONFIG_DN, [(ldap.MOD_REPLACE, 'alwaysrecordlogin', b'yes'),
+                                                            (ldap.MOD_REPLACE, 'stateattrname', b'lastLoginTime'),
+                                                            (ldap.MOD_REPLACE, 'altstateattrname', b'createTimestamp'),
+                                                            (ldap.MOD_REPLACE, 'specattrname', b'acctPolicySubentry'),
                                                             (ldap.MOD_REPLACE, 'limitattrname',
-                                                             'accountInactivityLimit')])
+                                                             b'accountInactivityLimit')])
 
     # Enable the plugins
     topology_st.standalone.plugins.enable(name=PLUGIN_ACCT_POLICY)
@@ -96,7 +96,7 @@ def test_ticket47714_run_0(topology_st):
     try:
         topology_st.standalone.simple_bind_s(TEST_USER_DN, TEST_USER_PW)
     except ldap.CONSTRAINT_VIOLATION as e:
-        log.error('CONSTRAINT VIOLATION ' + e.message['desc'])
+        log.error('CONSTRAINT VIOLATION {}'.format(e.args[0]['desc']))
 
     time.sleep(2)
 
@@ -109,7 +109,7 @@ def test_ticket47714_run_0(topology_st):
     try:
         topology_st.standalone.simple_bind_s(TEST_USER_DN, TEST_USER_PW)
     except ldap.CONSTRAINT_VIOLATION as e:
-        log.error('CONSTRAINT VIOLATION ' + e.message['desc'])
+        log.error('CONSTRAINT VIOLATION {}'.format(e.args[0]['desc']))
 
     time.sleep(2)
 
@@ -125,7 +125,7 @@ def test_ticket47714_run_0(topology_st):
 
     # Now, change the inactivity limit, because that should trigger the account to now be locked. This is possible because the check is "delayed" until the usage of the account.
 
-    topology_st.standalone.modify_s(ACCT_POLICY_DN, [(ldap.MOD_REPLACE, 'accountInactivityLimit', '1'),])
+    topology_st.standalone.modify_s(ACCT_POLICY_DN, [(ldap.MOD_REPLACE, 'accountInactivityLimit', b'1'),])
     time.sleep(2)
 
     entry = topology_st.standalone.search_s(ACCT_POLICY_DN, ldap.SCOPE_BASE, SEARCHFILTER)
@@ -137,13 +137,13 @@ def test_ticket47714_run_0(topology_st):
     try:
         topology_st.standalone.simple_bind_s(TEST_USER_DN, TEST_USER_PW)
     except ldap.CONSTRAINT_VIOLATION as e:
-        log.info('CONSTRAINT VIOLATION ' + e.message['desc'])
+        log.info('CONSTRAINT VIOLATION {}'.format(e.args[0]['desc']))
         log.info("%s was successfully inactivated." % TEST_USER_DN)
         pass
 
     # Now reset the value high to prevent issues with the next test.
     topology_st.standalone.simple_bind_s(DN_DM, PASSWORD)
-    topology_st.standalone.modify_s(ACCT_POLICY_DN, [(ldap.MOD_REPLACE, 'accountInactivityLimit', INACTIVITY_LIMIT),])
+    topology_st.standalone.modify_s(ACCT_POLICY_DN, [(ldap.MOD_REPLACE, 'accountInactivityLimit', ensure_bytes(INACTIVITY_LIMIT)),])
 
 
 def test_ticket47714_run_1(topology_st):
@@ -161,14 +161,14 @@ def test_ticket47714_run_1(topology_st):
     topology_st.standalone.modify_s(TEST_USER_DN, [(ldap.MOD_DELETE, 'lastLoginTime', None)])
 
     # Modify Account Policy config entry
-    topology_st.standalone.modify_s(ACCT_POLICY_CONFIG_DN, [(ldap.MOD_REPLACE, 'alwaysrecordlogin', 'yes'),
-                                                            (ldap.MOD_REPLACE, 'stateattrname', 'bogus'),
-                                                            (ldap.MOD_REPLACE, 'altstateattrname', 'modifyTimestamp'),
+    topology_st.standalone.modify_s(ACCT_POLICY_CONFIG_DN, [(ldap.MOD_REPLACE, 'alwaysrecordlogin', b'yes'),
+                                                            (ldap.MOD_REPLACE, 'stateattrname', b'bogus'),
+                                                            (ldap.MOD_REPLACE, 'altstateattrname', b'modifyTimestamp'),
                                                             (
-                                                            ldap.MOD_REPLACE, 'alwaysRecordLoginAttr', 'lastLoginTime'),
-                                                            (ldap.MOD_REPLACE, 'specattrname', 'acctPolicySubentry'),
+                                                            ldap.MOD_REPLACE, 'alwaysRecordLoginAttr', b'lastLoginTime'),
+                                                            (ldap.MOD_REPLACE, 'specattrname', b'acctPolicySubentry'),
                                                             (ldap.MOD_REPLACE, 'limitattrname',
-                                                             'accountInactivityLimit')])
+                                                             b'accountInactivityLimit')])
 
     # Enable the plugins
     topology_st.standalone.plugins.enable(name=PLUGIN_ACCT_POLICY)
@@ -179,7 +179,7 @@ def test_ticket47714_run_1(topology_st):
     try:
         topology_st.standalone.simple_bind_s(TEST_USER_DN, TEST_USER_PW)
     except ldap.CONSTRAINT_VIOLATION as e:
-        log.error('CONSTRAINT VIOLATION ' + e.message['desc'])
+        log.error('CONSTRAINT VIOLATION {}'.format(e.args[0]['desc']))
 
     time.sleep(1)
 
@@ -191,7 +191,7 @@ def test_ticket47714_run_1(topology_st):
     try:
         topology_st.standalone.simple_bind_s(TEST_USER_DN, TEST_USER_PW)
     except ldap.CONSTRAINT_VIOLATION as e:
-        log.error('CONSTRAINT VIOLATION ' + e.message['desc'])
+        log.error('CONSTRAINT VIOLATION {}'.format(e.args[0]['desc']))
 
     time.sleep(1)
 
diff --git a/dirsrvtests/tests/tickets/ticket47721_test.py b/dirsrvtests/tests/tickets/ticket47721_test.py
index db2ac61..ef57557 100644
--- a/dirsrvtests/tests/tickets/ticket47721_test.py
+++ b/dirsrvtests/tests/tickets/ticket47721_test.py
@@ -19,6 +19,8 @@ import pytest
 from lib389 import Entry
 from lib389._constants import *
 from lib389.topologies import topology_m2
+from lib389.replica import ReplicationManager
+from lib389.utils import *
 
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
@@ -57,24 +59,29 @@ SLEEP_INTERVAL = 60
 def _add_custom_at_definition(name='ATticket47721'):
     new_at = "( %s-oid NAME '%s' DESC 'test AT ticket 47721' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN ( 'Test 47721' 'user defined' ) )" % (
     name, name)
-    return new_at
+    return ensure_bytes(new_at)
 
 
 def _chg_std_at_defintion():
     new_at = "( 2.16.840.1.113730.3.1.569 NAME 'cosPriority' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 X-ORIGIN 'Netscape Directory Server' )"
-    return new_at
+    return ensure_bytes(new_at)
 
 
 def _add_custom_oc_defintion(name='OCticket47721'):
     new_oc = "( %s-oid NAME '%s' DESC 'An group of related automount objects' SUP top STRUCTURAL MUST ou X-ORIGIN 'draft-howard-rfc2307bis' )" % (
     name, name)
-    return new_oc
+    return ensure_bytes(new_oc)
 
 
 def _chg_std_oc_defintion():
     new_oc = "( 5.3.6.1.1.1.2.0 NAME 'trustAccount' DESC 'Sets trust accounts information' SUP top AUXILIARY MUST trustModel MAY ( accessTo $ ou ) X-ORIGIN 'nss_ldap/pam_ldap' )"
-    return new_oc
+    return ensure_bytes(new_oc)
 
+def replication_check(topology_m2):
+    repl = ReplicationManager(SUFFIX)
+    master1 = topology_m2.ms["master1"]
+    master2 = topology_m2.ms["master2"]
+    return repl.test_replication(master1, master2)
 
 def test_ticket47721_init(topology_m2):
     """
@@ -94,7 +101,7 @@ def test_ticket47721_init(topology_m2):
         'userpassword': BIND_PW})))
 
     # enable repl error logging
-    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', str(8192))]  # REPL logging
+    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', ensure_bytes(str(8192)))]  # REPL logging
     topology_m2.ms["master1"].modify_s(DN_CONFIG, mod)
     topology_m2.ms["master2"].modify_s(DN_CONFIG, mod)
 
@@ -109,17 +116,9 @@ def test_ticket47721_init(topology_m2):
 
 def test_ticket47721_0(topology_m2):
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
-    loop = 0
-    ent = None
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            break
-        except ldap.NO_SUCH_OBJECT:
-            time.sleep(1)
-            loop += 1
-    if ent is None:
-        assert False
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ent
 
 
 def test_ticket47721_1(topology_m2):
@@ -143,20 +142,13 @@ def test_ticket47721_1(topology_m2):
     topology_m2.ms["master1"].log.info("Chg (M2) %s " % new)
     topology_m2.ms["master2"].schema.add_schema('objectClasses', new)
 
-    mod = [(ldap.MOD_REPLACE, 'description', 'Hello world 1')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'Hello world 1')]
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
     topology_m2.ms["master2"].modify_s(dn, mod)
 
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master1"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'Hello world 1'):
-                break
-        except ldap.NO_SUCH_OBJECT:
-            loop += 1
-        time.sleep(1)
-    assert loop <= 10
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master1"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'Hello world 1'
 
     time.sleep(2)
     schema_csn_master1 = topology_m2.ms["master1"].schema.get_schema_csn()
@@ -168,20 +160,13 @@ def test_ticket47721_1(topology_m2):
 def test_ticket47721_2(topology_m2):
     log.info('Running test 2...')
 
-    mod = [(ldap.MOD_REPLACE, 'description', 'Hello world 2')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'Hello world 2')]
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
     topology_m2.ms["master1"].modify_s(dn, mod)
 
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'Hello world 2'):
-                break
-        except ldap.NO_SUCH_OBJECT:
-            loop += 1
-        time.sleep(1)
-    assert loop <= 10
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'Hello world 2'
 
     time.sleep(2)
     schema_csn_master1 = topology_m2.ms["master1"].schema.get_schema_csn()
@@ -222,20 +207,13 @@ def test_ticket47721_3(topology_m2):
     topology_m2.ms["master2"].schema.add_schema('objectClasses', new)
     time.sleep(1)
 
-    mod = [(ldap.MOD_REPLACE, 'description', 'Hello world 3')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'Hello world 3')]
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
     topology_m2.ms["master1"].modify_s(dn, mod)
 
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'Hello world 3'):
-                break
-        except ldap.NO_SUCH_OBJECT:
-            loop += 1
-        time.sleep(1)
-    assert loop <= 10
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'Hello world 3'
 
     time.sleep(5)
     schema_csn_master1 = topology_m2.ms["master1"].schema.get_schema_csn()
@@ -273,36 +251,22 @@ def test_ticket47721_4(topology_m2):
     topology_m2.ms["master1"].schema.add_schema('objectClasses', new)
 
     topology_m2.ms["master1"].log.info("trigger replication M1->M2: to update the schema")
-    mod = [(ldap.MOD_REPLACE, 'description', 'Hello world 4')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'Hello world 4')]
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
     topology_m2.ms["master1"].modify_s(dn, mod)
 
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'Hello world 4'):
-                break
-        except ldap.NO_SUCH_OBJECT:
-            loop += 1
-        time.sleep(1)
-    assert loop <= 10
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'Hello world 4'
 
     topology_m2.ms["master1"].log.info("trigger replication M1->M2: to push the schema")
-    mod = [(ldap.MOD_REPLACE, 'description', 'Hello world 5')]
+    mod = [(ldap.MOD_REPLACE, 'description', b'Hello world 5')]
     dn = "cn=%s0,%s" % (OTHER_NAME, SUFFIX)
     topology_m2.ms["master1"].modify_s(dn, mod)
 
-    loop = 0
-    while loop <= 10:
-        try:
-            ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
-            if ent.hasAttr('description') and (ent.getValue('description') == 'Hello world 5'):
-                break
-        except ldap.NO_SUCH_OBJECT:
-            loop += 1
-        time.sleep(1)
-    assert loop <= 10
+    replication_check(topology_m2)
+    ent = topology_m2.ms["master2"].getEntry(dn, ldap.SCOPE_BASE, "(objectclass=*)")
+    assert ensure_str(ent.getValue('description')) == 'Hello world 5'
 
     time.sleep(2)
     schema_csn_master1 = topology_m2.ms["master1"].schema.get_schema_csn()
